'currently this routine only supports the non-"special" routines.

include .\helpers.prg
include .\library.prg

'default output series name
%outname = "Out"

logmode +addin

'get the name of the group object.  
%type = @getthistype
if %type="NONE" then
	@uiprompt("No object found, please open a GROUP object")
	stop
endif

'check that _this object is a group
if %type<>"GROUP" then
	@uiprompt("Procedure can only be run from a GROUP object")
	stop
endif
%gname = _this.@name
if %gname = "" then  'this can occur if the group is untitled.
	%gname = "_this"
endif

'names of the series in the group
%inputnames = {%gname}.@members

'variable that will contain which inputs are in the group
%inputs = ""

!hidx = 0  'index of the high series in the group
!lidx = 0
!oidx = 0
!cidx = 0
!vidx = 0

'analyse the series in the group for inputs
for !i=1 to @wcount(%inputnames)
	%name = @word(%inputnames,!i)
	if @instr(%name,"high") or @instr(%name,"HIGH") then
		%inputs = %inputs + "h"
		!hidx = !i
	endif
	if @instr(%name,"low") or @instr(%name,"LOW") then
		%inputs = %inputs + "l"
		!lidx = !i
	endif
	if @instr(%name,"open") or @instr(%name,"OPEN") then
		%inputs = %inputs + "o"
		!oidx = !i
	endif
	if @instr(%name,"close") or @instr(%name,"CLOSE") then
		%inputs = %inputs + "c"
		!cidx = !i
	endif
	if @instr(%name,"volume") or @instr(%name,"VOLUME") then
		%inputs = %inputs + "v"
		!vidx = !i
	endif
next


'get list of available functions
%index = ""
call matchfuncs(%inputs,%index)
%funcnames = ""
call getfuncnamesidx(%funcnames,%index)
%funcdiscs = ""
call getfuncdiscsidx(%funcdiscs,%index)
%inputtypes = ""
call getinputtypesidx(%inputtypes,%index)

if %funcnames = "" then
	@uiprompt("No available methods for selected series")
	stop
endif

!chosen=1
'throw up the dialog with the list of methods, and an edit box asking for the output name.
!result = @uidialog("edit",%outname,"Name of created output series","list",!chosen,"Select a method",%funcdiscs)
if !result = -1 then
	stop
endif
'work out if an extra dialog with a parameter input is required
%inputs = @word(%inputtypes,!chosen)
if @right(%inputs,1) = "s" then
	%param = ""
	!result = @uidialog("edit",%param,"Periods/Parameter")
endif

'build up input argument string
%subarg = %outname + ", "
if !hidx>0 then
	%subarg = %subarg + {%gname}.@seriesname(!hidx) + ", "
endif
if !lidx>0 then
	%subarg = %subarg + {%gname}.@seriesname(!lidx) + ", "
endif
if !oidx>0 then
	%subarg = %subarg + {%gname}.@seriesname(!oidx) + ", "
endif
if !cidx>0 then
	%subarg = %subarg + {%gname}.@seriesname(!cidx) + ", "
endif
if !vidx>0 then
	%subarg = %subarg + {%gname}.@seriesname(!vidx) + ", "
endif
%subarg = %subarg + %param
%subarg = @stripcommas(%subarg)

'get the name of the chosen function
%chosen = @word(%funcnames,!chosen)

'make output series
series {%outname}

'call the chosen function
call {%chosen}({%subarg})

%grname = %chosen
if @isobject(%grname ) then
	%grname = @getnextname(%grname)
endif
freeze({%grname}) {%outname}.line
%grtitle = @word(%funcdiscs,!chosen)
{%grname}.addtext(t, font(16)) %grtitle
{%gname}.display {%grname}
