include .\library.prg
include .\helpers.prg

logmode +addin
logmode +debug

'retrieve the list of function descriptions.  This list will be used to populate the list box dialog.
%funcdiscs = ""
call getfuncdiscs(%funcdiscs)
!chosen = 1
%outname = "Out"
'throw up the dialog with the list of methods, and an edit box asking for the output name.
!result = @uidialog("edit",%outname,"Name of created output series","list",!chosen,"Select a method",%funcdiscs)
if !result = -1 then
	stop
endif

%funcnames = ""
call getfuncnames(%funcnames)

%chosen = @word(%funcnames,!chosen)

%inputtypes = ""
call getinputtypes(%inputtypes)

%input = @word(%inputtypes,!chosen)


'input series/parameter values.  Defaulted to empty.
%high = ""      
%low = ""
%open = ""
%close = ""
%volume = ""
%param = ""
%param2 = ""
%param3 = ""
%param4 = ""


!requiredinputs = 0    'how many inputs are requierd.  This number will be checked against the number of inputs they entered.

'start the dialog creation string
%inputfields = "!result = @uidialog("
'some routines have non-standard inputs, thus they need to have special-case handling for creating of the input dialog
if %input = "special" then
	if %chosen = "bollinger" then
		%param2 = ""
		%inputfields = %inputfields + """edit"",%close,""Close Series"",""edit"",%param,""Moving average length"",""edit"",%param2,""Deviations"","
		!requiredinputs = 3	
		%high=""
		%low=""
		%open=""
		%volume=""
	endif
	if %chosen = "csi" or %chosen = "directmov" then
		%param2 = ""
		%param3 = ""
		%param4 = ""
		%inputfields = %inputfields + """edit"",%high,""High Series"",""edit"",%low,""Low Series"",""edit"",%open,""Open Series"", ""edit"",%close,""Close Series"", ""edit"", %param, ""Periods"", ""edit"", %param2, ""Value of a 1 cent move"", ""edit"", %param3, ""Margin Requirement"", ""edit"", %param4, ""Commission"","
		!requiredinputs = 8
		%volume=""
	endif
	if %chosen = "movav" then
		%param2 = "Simple"
		%inputfields = %inputfields + """edit"",%close,""Input Series"",""edit"",%param,""Periods"", ""list"",%param2,""Moving Average Type"", ""Simple Exponential Triangular Weighted"","
		!requiredinputs = 3
		%high=""
		%low=""
		%open=""
		%volume=""
	endif
	if %chosen = "priceosc" then
		%param2 = ""
		%inputfields = %inputfields + """edit"",%close,""Input Series"",""edit"",%param,""Period 1 Length"",""edit"",%param2,""Period 2 Length"","
		!requiredinputs = 3
		%high=""
		%low=""
		%open=""
		%volume=""	
	endif
	if %chosen = "ri" then
		%param2 = ""
		%inputfields = %inputfields + """edit"",%high,""High Series"",""edit"",%low,""Low Series"",""edit"",%close,""Close Series"", ""edit"",%volume,""Volume Series"",""edit"", %param, ""Periods"",""edit"",%param2,""Moving Average Length""," 
		!requiredinputs = 6
		%open=""
	endif
	if %chosen = "smi" then
		%param2 = ""
		%inputfields = %inputfields + """edit"",%high,""High Series"",""edit"",%low,""Low Series"",""edit"",%close,""Close Series"", ""edit"", %param, ""Smoothing Periods"",""edit"",%param2,""Double Smoothing Periods""," 	
		!requiredinputs = 5
		%open=""
		%volume=""
	endif
	if %chosen = "stochosc" then
		%param2 = ""
		%param3 = ""
		%param4 = "Simple"
		%inputfields = %inputfields + """edit"",%high,""High Series"",""edit"",%low,""Low Series"",""edit"",%close,""Close Series"",""edit"",%param,""K-Periods"",""edit"",%param2,""K-Slowing Periods"",""edit"",%param3,""D-Periods"", ""list"",%param4,""Moving Average Type"", ""Simple Exponential Triangular Weighted"","	
		!requiredinputs = 7
		%open=""
		%volume=""
	endif
	if %chosen = "volosc" then
		%param2 = ""
		%inputfields = %inputfields + """edit"",%volume,""Volume Series"",""edit"",%param,""Short Period"",""edit"",%param2,""Long Period"","
		!requiredinputs = 3
		%high=""
		%low=""
		%open=""
		%close=""
	endif
else  'for non-special cases, we can construct the dialogs dynamically by adding the required fields one at a time.
	if @instr(%input,"h")>0 then
		%inputfields = %inputfields + """edit"",%high,""High Series"","
		!requiredinputs = !requiredinputs + 1
	else
		%high = ""
	endif
	if @instr(%input,"l")>0 then
		%inputfields = %inputfields + """edit"",%low,""Low Series"","
		!requiredinputs = !requiredinputs + 1
	else
		%low = ""
	endif
	if @instr(%input,"o")>0 then
		%inputfields = %inputfields + """edit"",%open,""Open Series"","
		!requiredinputs = !requiredinputs + 1
	else
		%open = ""
	endif
	if @instr(%input,"c")>0 then
		%inputfields = %inputfields + """edit"",%close,""Close Series"","
		!requiredinputs = !requiredinputs + 1
	else
		%close = ""
	endif
	if @instr(%input,"v")>0 then
		%inputfields = %inputfields + """edit"",%volume,""Volume Series"","
		!requiredinputs = !requiredinputs + 1
	else
		%volume = ""
	endif
	if @instr(%input,"s")>0 then
		%inputfields = %inputfields + """edit"",%param,""Parameter Value"","
		!requiredinputs = !requiredinputs + 1
	else
		%param = ""
	endif
endif

'trim any errant commas
%inputfields = @stripcommas(%inputfields)

'finish the dialog creation string
%inputfields = %inputfields + ",""caption"",""Select the input series"")"

'run the dialog creation string.
{%inputfields}
if !result = -1 then
	stop
endif

'create the output series names
%outnames = %outname + ", "
if %chosen = "bollinger" then
	%highname = %outname + "_high"
	%outnames = %outnames + %highname + ", "
	%lowname = %outname + "_low, "
	%outnames = %outnames + %lowname	
endif
if %chosen = "directmov" then
	%pdiname = %outname + "_pdi"
	%mdiname = %outname + "_mdi"
	%dxname = %outname + "_dx"
	%adxname = %outname + "_adx"
	%adxrname = %outname + "_adxr"
	%csiname = %outname + "_csi"
	%outnames = %pdiname + ", " + %mdiname + ", " + %dxname + ", " + %adxname + ", " + %adxrname + ", " + %csiname +"," 
endif

'create all the output series
%groupname = %outname + "_g"
if @isobject(%groupname) then
	%groupname = @getnextname(%groupname)
endif
group {%groupname}
for !i=1 to @wcount(%outnames)
	%name = @word(%outnames,!i)
	%name = @stripcommas(%name)
	series {%name}
	{%groupname}.add {%name}
next
'start the subroutine call string
%subargs =  %outnames

!numofgivenparams = 0  'counter that keeps track of how many parameters they entered in the dialog

'add the inputs to the call string
if @length(%high)>0 then
	%subargs = %subargs + %high + ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%low)>0 then
	%subargs = %subargs + %low+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%open)>0 then
	%subargs = %subargs + %open+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%close)>0 then
	%subargs = %subargs + %close+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%volume)>0 then
	%subargs = %subargs + %volume+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%param)>0 then
	%subargs = %subargs + %param+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%param2)>0 then
	%subargs = %subargs + %param2+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%param3)>0 then
	%subargs = %subargs + %param3+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
if @length(%param4)>0 then
	%subargs = %subargs + %param4+ ","
	!numofgivenparams = !numofgivenparams + 1
endif 
'finish the call string
%subargs = @stripcommas(%subargs)

'check the number of params is correct
if !numofgivenparams <> !requiredinputs then
	@uiprompt("Incorrect number of inputs")
	stop
endif

'call the selected subroutine, with the correct arguments
call {%chosen}({%subargs})

%gname = %chosen
if @isobject(%gname ) then
	%gname = @getnextname(%gname)
endif
freeze({%gname}) {%groupname}.line
%gtitle = @word(%funcdiscs,!chosen)
{%gname}.addtext(t, font(16)) %gtitle
'exec "shade recessions" {%gname}
{%groupname}.display {%gname}
