include .\helpers.prg
include .\library.prg

'default output series name
%outname = "Out"

logmode +addin

'get the name of the series object.
'check that an object exists
%type = @getthistype
if %type="NONE" then
	@uiprompt("No object found, please open a SERIES object")
	stop
endif

'check that _this object is a series
if %type<>"SERIES" then
	@uiprompt("Procedure can only be run from a SERIES object")
	stop
endif
%sname = _this.@name
if %sname = "" then  'this can occur if the series is untitled.
	%sname = "_this"
endif


%inputs = "c"  'since we're in a series, we only look for functions that require a single, close, series.

'get list of available functions
%index = ""
call matchfuncs(%inputs,%index)
%funcnames = ""
call getfuncnamesidx(%funcnames,%index)
%funcdiscs = ""
call getfuncdiscsidx(%funcdiscs,%index)
%inputtypes = ""
call getinputtypesidx(%inputtypes,%index)

!chosen=1
'throw up the dialog with the list of methods, and an edit box asking for the output name.
!result = @uidialog("edit",%outname,"Name of created output series","list",!chosen,"Select a method",%funcdiscs)
if !result = -1 then
	stop
endif
'work out if an extra dialog with a parameter input is required
%inputs = @word(%inputtypes,!chosen)
if @right(%inputs,1) = "s" then
	%param = ""
	!result = @uidialog("edit",%param,"Periods")
endif

'build up input argument string
%subarg = %outname + ", " + %sname + ", " + %param
%subarg = @stripcommas(%subarg)

'get the name of the chosen function
%chosen = @word(%funcnames,!chosen)

'make output series
series {%outname}

'call the chosen function
call {%chosen}({%subarg})

%grname = %chosen
if @isobject(%grname ) then
	%grname = @getnextname(%grname)
endif
freeze({%grname}) {%outname}.line
%grtitle = @word(%funcdiscs,!chosen)
{%grname}.addtext(t, font(16)) %grtitle
{%sname}.display {%grname}

d {%grname}
